︠ef1624d3-cb7c-41db-9696-9945341b20c7i︠
%html
npi = RDF(pi)
from math import cos,sin
def rot(t):
    return matrix([[cos(t),sin(t)],[-sin(t),cos(t)]])

def pursuit(n,x0,y0,lamb,steps = 100, threshold = .01):
    paths = [[[x0,y0]]]
    for i in range(1,n):
        rx,ry = list(rot(2*npi*i/n)*vector([x0,y0]))
        paths.append([[rx,ry]])
    oldpath = [x[-1] for x in paths]
    for q in range(steps):
        diffs = [[oldpath[(j+1)%n][0]-oldpath[j][0],oldpath[(j+1)%n][1]-oldpath[j][1]] for j in range(n)]
        npath = [[oldpath[j][0]+lamb*diffs[j][0],oldpath[j][1]+lamb*diffs[j][1]] for j in range(n)]
        for j in range(n):
            paths[j].append(npath[j])
        oldpath = npath
    return paths
html('<h3>Curves of Pursuit</h3>')
@interact
def curves_of_pursuit(n = slider([2..20],default = 5, label="# of points"),steps = slider([floor(1.4^i) for i in range(2,18)],default = 10, label="# of steps"), stepsize = slider(srange(.01,1,.01),default = .2, label="stepsize"), colorize = selector(['BW','Line color', 'Filled'],default = 'BW')):
    outpaths = pursuit(n,0,1,stepsize, steps = steps)
    mcolor = (0,0,0)
    outer = line([q[0] for q in outpaths]+[outpaths[0][0]], rgbcolor = mcolor)
    polys = Graphics()
    if colorize=='Line color':
        colors = [hue(j/steps,1,1) for j in range(len(outpaths[0]))]
    elif colorize == 'BW':
        colors = [(0,0,0) for j in range(len(outpaths[0]))]
    else:
        colors = [hue(j/steps,1,1) for j in range(len(outpaths[0]))]
        polys = sum([polygon([outpaths[(i+1)%n][j+1],outpaths[(i+1)%n][j], outpaths[i][j+1]], rgbcolor = colors[j]) for i in range(n) for j in range(len(outpaths[0])-1)])
        #polys = polys[0]
        colors = [(0,0,0) for j in range(len(outpaths[0]))]
    nested = sum([line([q[j] for q in outpaths]+[outpaths[0][j]], rgbcolor = colors[j]) for j in range(len(outpaths[0]))])
    lpaths = [line(x, rgbcolor = mcolor) for x in outpaths]
    show(sum(lpaths)+nested+polys, axes = False, figsize = [5,5], xmin = -1, xmax = 1, ymin = -1, ymax =1)

︡0a03c57e-1c11-49c3-9954-482fbd52b25f︡{"html": "npi = RDF(pi)\r\nfrom math import cos,sin\r\ndef rot(t):\r\n    return matrix([[cos(t),sin(t)],[-sin(t),cos(t)]])\r\n\r\ndef pursuit(n,x0,y0,lamb,steps = 100, threshold = .01):\r\n    paths = [[[x0,y0]]]\r\n    for i in range(1,n):\r\n        rx,ry = list(rot(2*npi*i/n)*vector([x0,y0]))\r\n        paths.append([[rx,ry]])\r\n    oldpath = [x[-1] for x in paths]\r\n    for q in range(steps):\r\n        diffs = [[oldpath[(j+1)%n][0]-oldpath[j][0],oldpath[(j+1)%n][1]-oldpath[j][1]] for j in range(n)]\r\n        npath = [[oldpath[j][0]+lamb*diffs[j][0],oldpath[j][1]+lamb*diffs[j][1]] for j in range(n)]\r\n        for j in range(n):\r\n            paths[j].append(npath[j])\r\n        oldpath = npath\r\n    return paths\r\nhtml('<h3>Curves of Pursuit</h3>')\r\n@interact\r\ndef curves_of_pursuit(n = slider([2..20],default = 5, label=\"# of points\"),steps = slider([floor(1.4^i) for i in range(2,18)],default = 10, label=\"# of steps\"), stepsize = slider(srange(.01,1,.01),default = .2, label=\"stepsize\"), colorize = selector(['BW','Line color', 'Filled'],default = 'BW')):\r\n    outpaths = pursuit(n,0,1,stepsize, steps = steps)\r\n    mcolor = (0,0,0)\r\n    outer = line([q[0] for q in outpaths]+[outpaths[0][0]], rgbcolor = mcolor)\r\n    polys = Graphics()\r\n    if colorize=='Line color':\r\n        colors = [hue(j/steps,1,1) for j in range(len(outpaths[0]))]\r\n    elif colorize == 'BW':\r\n        colors = [(0,0,0) for j in range(len(outpaths[0]))]\r\n    else:\r\n        colors = [hue(j/steps,1,1) for j in range(len(outpaths[0]))]\r\n        polys = sum([polygon([outpaths[(i+1)%n][j+1],outpaths[(i+1)%n][j], outpaths[i][j+1]], rgbcolor = colors[j]) for i in range(n) for j in range(len(outpaths[0])-1)])\r\n        #polys = polys[0]\r\n        colors = [(0,0,0) for j in range(len(outpaths[0]))]\r\n    nested = sum([line([q[j] for q in outpaths]+[outpaths[0][j]], rgbcolor = colors[j]) for j in range(len(outpaths[0]))])\r\n    lpaths = [line(x, rgbcolor = mcolor) for x in outpaths]\r\n    show(sum(lpaths)+nested+polys, axes = False, figsize = [5,5], xmin = -1, xmax = 1, ymin = -1, ymax =1)"}︡
